<template>
  <div>
    <el-breadcrumb style="font-size: 24px; margin-top: 16px; margin-bottom: 32px;" separator=">">
      <el-breadcrumb-item v-if="currentTeachingClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentTeachingClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item v-if="currentStudyingClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentStudyingClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item v-if="currentPreviewClass(classId) !== undefined" :to="{ path: '/a/teacher/NNclass/'+classId }">{{ currentPreviewClass(classId).name }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ $t('CLASS_MENU.BOARD') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('ITEM_FROM_BANK.BACK') }}</el-button>
        </a>
      </div> -->
    </el-breadcrumb>
    <el-input :placeholder="$t('BOARD.ENTER_POST_TITLE')" v-model="name"></el-input>
    <el-input :placeholder="$t('BOARD.ENTER_POST_CNT')" v-model="content" type="textarea" :autosize="{ minRows: 10, maxRows: 15 }"></el-input>
    <div>
      <el-upload
        class="upload-demo"
        action="#"
        :on-remove="handleRemove"
        :before-remove="beforeRemove"
        multiple
        :limit="3"
        :on-exceed="handleExceed"
        :http-request="doUpload">
        <el-button size="small" type="primary">{{ $t('BOARD.UPLOAD_FILE') }}</el-button>
        <el-button size="small" type="text"> &#42; {{ $t('MATERIAL.NOTYPE') }} </el-button>
      </el-upload>
    </div>
    <div v-if="storedFileList.length > 0">
      <hr>
      <h4>{{ $t('BOARD.ATTACH_FILE') }}</h4>
      <div :key="file.file_guid" v-for="file in storedFileList" style="margin: 20px 0px 20px 10px;">
        <span>{{ $t('MATERIAL.NAME') }} : {{ file.name }} </span>
        <el-button type="danger" @click="onClick('DELETEFILE',file.file_guid)">X</el-button>
      </div>
    </div>
    <hr>
    <div>
      <el-button @click="onClick('WRITE')" plain>{{ $t('BOARD.SAVE') }}</el-button>
      <el-button @click="onClick('CANCEL')" plain>{{ $t('BOARD.CANCEL') }}</el-button>
    </div>
  </div>
</template>

<script>
import { mapState, mapGetters, mapActions } from 'vuex';

export default {
  created() {
    if (this.modifyMode === true) {
      // 이상한 경로로 접근하는 경우 vuex에 값이 남아있을 수도 있을것 같아서 가급적 component.$data로 옮겨서 사용합니다.
      this.setModifyMode({ flag: false });
      this.$data.ModifyMode = true;
      this.$data.name = this.post.name;
      this.$data.content = this.post.content;
      this.$data.storedFileList = this.post.files;
    }
  },
  computed: {
    ...mapState('board', [
      'modifyMode',
      'post',
    ]),
    ...mapGetters('NNclass', [
      'currentTeachingClass',
      'currentStudyingClass',
      'currentPreviewClass',
    ]),
    classId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.classId, 10);
    },
  },
  methods: {
    ...mapActions('board', [
      'postPost',
      'setModifyMode',
      'modifyPost',
      'postFile',
      'deleteFile',
      'postFileWithID',
    ]),
    async onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'WRITE': {
          // fileUidGuidMap를 기반으로 GuidList를 생성
          const fileGuidList = [];
          this.$data.fileUidGuidMap.forEach((element) => {
            fileGuidList.push(element.guid);
          });
          if (vm.$data.ModifyMode === true) {
            await vm.modifyPost({
              classId: this.$route.params.classId,
              name: vm.$data.name,
              content: vm.$data.content,
              fileGuid: fileGuidList,
              boardId: vm.post.board_id,
            });
          } else {
            await vm.postPost({
              classId: this.$route.params.classId,
              name: vm.$data.name,
              content: vm.$data.content,
              fileGuid: fileGuidList,
            });
          }
          vm.$router.push(`/a/class/${this.$route.params.classId}/board/0`);
          break;
        }
        case 'CANCEL': {
          vm.$router.go(-1);
          break;
        }
        case 'DELETEFILE': {
          const res = await vm.deleteFile({
            fileGuid: arg,
          });
          if (res.data.success !== true) {
            break;
          }
          vm.$data.storedFileList.forEach((element, index) => {
            if (element.file_guid === arg) {
              vm.$data.storedFileList.splice(index, 1);
            }
          });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
    handleRemove(file) {
      // 파일 삭제 시, GuidMap 에서도 해당 파일 삭제
      this.$data.fileUidGuidMap.forEach((element, index) => {
        if (element.uid === file.uid) {
          this.$data.fileUidGuidMap.splice(index, 1);
        }
      });
    },
    handleExceed(files, fileList) {
      this.$message.warning(`The limit is 3, you selected ${files.length} files this time, add up to ${files.length + fileList.length} totally`);
    },
    beforeRemove(file) {
      return this.$confirm(this.$t('CONFIRM.WANT_RM') + ` ${file.name} ` + this.$t('CONFIRM.FILE'));
    },
    async doUpload(req) {
      if (this.$data.ModifyMode === false) {
        const res = await this.postFile({
          file: req.file,
        });
        this.$data.fileUidGuidMap.push({
          uid: req.file.uid,
          guid: res.data.fileGuid,
        });
      } else {
        const res = await this.postFileWithID({
          classId: this.$route.params.classId,
          boardId: this.post.board_id,
          file: req.file,
        });
        this.$data.fileUidGuidMap.push({
          uid: req.file.uid,
          guid: res.data.file.fileGuid,
        });
      }
    },
  },
  data() {
    return {
      name: '',
      content: '',
      ModifyMode: false, // 수정 상태라면 true, 쓰기로 들어왔다면 false
      fileUidGuidMap: [], // el-upload 에서 전해주는 uid 값과 node Server에서 반환받은 guid값을 연결할 용도로 사용
      storedFileList: [], // detail -> 수정 으로 넘어온 경우 기존에 갖고 있던 첨부파일 목록을 보관
    };
  },
};
</script>